#!/bin/sh

#### Find out where we are (more reliable than pwd with rox)
MYDIR=`echo $0|sed 's/[^/]*$//'|sed 's/\/$//'`

if [ "$MYDIR" = "." ]; then
  MYDIR=`pwd`
fi


#FOLDER=~
FOLDER=/usr/local

#### normal users (not root) just are allowed to extract to their /home
if [ "$FOLDER" != ~ ]; then
  IAM=`whoami`
  if [ "$IAM" != "root" ]; then
     xmessage -nearmouse "ERROR: You must be root to install wxbasicscript-unzipdemo, exiting..."
     exit
  fi
fi

if [ ! -d "$FOLDER" ] ;then
  mkdir $FOLDER
fi

cd $FOLDER

#### If folder exists and is empty (PCCC does not remove it), start uninstaller
ACTION=install
if [ -d "wxbasicscript-unzipdemo" ]; then
  ISEMPTY=`ls wxbasicscript-unzipdemo`
  if [ "$ISEMPTY" != "" ]; then
    ACTION=`xmessage -nearmouse -print -buttons un-install,re-install "wxbasicscript-unzipdemo already exists, your choice?"`
  fi
fi

echo $ACTION

#### Uninstall
if [ "$ACTION" = "un-install" ]; then

   if [ -f "/root/.packages/wxbasicscript-unzipdemo.files" ];then
      xmessage -nearmouse "Please uninstall with Pup-get Package-manager! - STOPPED -"
      exit 0
   fi
   ### just to be sure not to delete /usr/local or ~ by accident
   if [ "$FOLDER/wxbasicscript-unzipdemo" != "$FOLDER/" ];then
     rm -rf $FOLDER/wxbasicscript-unzipdemo
   fi
   xmessage -nearmouse "Finished, wxbasicscript-unzipdemo was uninstalled"
   exit 0
fi

if [ "$ACTION" = "re-install" ]; then
  ACTION=install
fi

if [ "$ACTION" != "install" ]; then
   exit 0
fi


#### install

##V03 #######################################################
# extract FILESYSTEM.tgz



# first check, if files already exist
 echo "the following files already exist:\n\n" > $MYDIR/existing.txt

 rm -f  "$MYDIR/existing.txt"
 tar -tzf $MYDIR/FILESYSTEM.tgz | while read a; do 

    echo "/$a" >> "$MYDIR/_test.txt"

 if [ -f "/$a" ] ; then
    echo "/$a" >> "$MYDIR/existing.txt"
 fi

 done

 if [ -f "$MYDIR/existing.txt" ]; then

        FILES=`cat "$MYDIR/existing.txt"`
        MSG="These files already exist, overwrite them?\n\n$FILES"
  Xdialog --title "info" --yesno "$MSG" 0 0

  if [ "$?" != "0" ];then
    Xdialog --title "info" --msgbox "Installation canceled, exiting..." 0 0
    exit 0
  fi
 fi

cd /
tar -xzvf $MYDIR/FILESYSTEM.tgz

##/V03 #######################################################



#### extract archive
  cd $FOLDER
  tar -xzvf $MYDIR/wxbasicscript-unzipdemo.tgz

  #### were there any errors?
  if [ ! -d "$FOLDER/wxbasicscript-unzipdemo" ]; then
    xmessage -nearmouse "Error during extraction - are you root?"
    exit 1
  fi




#############################
## generate Entry for wxB-menue

if [ -f "$MYDIR/wxbmenue.rc" ];then

MYFILE=`head -n 1 "$MYDIR/wxbmenue.rc"`
rm -f /tmp/mrc1

  FILE=$FOLDER/$MYFILE
  echo "<?xml version=\"1.0\"?>" >/tmp/mrc1
  echo "<RootMenu>" >>/tmp/mrc1
  echo "<Menu label=\"DotPups\" icon=\"nothing.xpm\">" >>/tmp/mrc1

  ### check, if there already is a "DotPups"-submenue
  MENUEXISTED=1
  MYGREP=`grep "<Menu label=\"DotPups\"" ~/.myownmenuerc`
  if [ "$MYGREP" = "" ];then
    MENUEXISTED=0
  fi
  ### delete old entries
  rm -f /tmp/mrc0
  cat ~/.myownmenuerc |sed "s^<Program.label=.wxbasicscript-unzipdemo..*$g" |while read a ;
  do if [ "$a" ];then echo $a>>/tmp/mrc0;fi;done

  if [ "$MYFILE" ];then 
    echo "<Program label=\"wxbasicscript-unzipdemo\" icon=\"$FOLDER/wxbasicscript-unzipdemo/icon.xpm\">$FILE</Program>" >>/tmp/mrc1
  fi
  if [ "$MENUEXISTED" = "0" ];then
    echo "</Menu>" >>/tmp/mrc1
  fi

  cat /tmp/mrc0 |sed "s/<.xml.*$//" |sed "s/<RootMenu>.*$//"  |sed "s/<.RootMenu>.*$//" |sed "s/<Menu.label=.DotPups.*$//" |sed "s/^$//g" |while read a ;
  do if [ "$a" ];then echo $a>>/tmp/mrc1;fi;done

  echo "</RootMenu>" >>/tmp/mrc1
  cp  ~/.myownmenuerc  ~/.myownmenuerc.bak
  mv /tmp/mrc1  ~/.myownmenuerc
  if [ "$MYFILE" ];then 
      #xmessage -nearmouse "added entry to wxB-Menue. You must restart the menue to see it."
INSTALLEDMENUES1="wxB-Menue"
  fi
  rm -f /tmp/mrc0
fi

  MYFILE=`head -n 1 "$MYDIR/wxbmenue.rc"`
  BINARYNAME=`echo $MYFILE | sed "s^.*/"`

#############################
## generate Entry for fvwm95
  ### register in the fvwm95 menu
  # entry is placed just above smm
  FVWM95RC="/root/.fvwm95rc"
  if [ -f $FVWM95RC ] ; then

  MYGREP=`grep "AddToMenu \"DotPups\"" $FVWM95RC`
  if [ "$MYGREP" = "" ];then

      cp -f $FVWM95RC /tmp/DOTfvwm95.pwizard_patched.backup
      EDITTEXT="s\(Popup.UtilityApps$\)\1\n+ \"DotPups%package.xpm%\" Popup DotPups"
      sed -e "$EDITTEXT" $FVWM95RC >/tmp/patchedinstall.tmp
      sleep 1
      echo "DestroyMenu \"DotPups\"" >>/tmp/patchedinstall.tmp
      echo "AddToMenu \"DotPups\"" >>/tmp/patchedinstall.tmp
      mv -f /tmp/patchedinstall.tmp $FVWM95RC
      sleep 1
  fi

    # this option is used to prevent the entry from going in more than once
    grep "$FOLDER/$MYFILE" $FVWM95RC
    if [ $? -ne 0 ] ;then
      cp -f $FVWM95RC /tmp/DOTfvwm95.pwizard_patched.backup
      EDITTEXT="s^\(AddToMenu.\"DotPups\".*$\)\1\n+ \"$BINARYNAME%$FOLDER/wxbasicscript-unzipdemo/icon.xpm%\" Exec exec $FOLDER/$MYFILE"
      sed -e "$EDITTEXT" $FVWM95RC >/tmp/patchedinstall.tmp
      mv -f /tmp/patchedinstall.tmp $FVWM95RC
      sleep 1
INSTALLEDMENUES2="Fvwm95"

    fi
  fi 

#############################
## generate Entry for icewm
  ### register in the icewm menu
  # entered just above smm
  ICEWMMENU="/root/.icewm/menu"

  if [ -f $ICEWMMENU ] ; then
  MYGREP=`grep "menu \"DotPups\"" $ICEWMMENU`
  if [ "$MYGREP" = "" ];then
    echo "menu \"DotPups\" dotpups {" >>$ICEWMMENU
    echo "}" >>$ICEWMMENU
  fi

    # this option is used to prevent the entry from going in more than once
    grep "$FOLDER/$MYFILE" $ICEWMMENU
    if [ $? -ne 0 ] ;then
      cp -f $ICEWMMENU /tmp/icewmmenu.pwizard.backup
      EDITTEXT="s^\(menu.\"DotPups\".dotpups.{\)\1\n\tprog \"$BINARYNAME\" \"$FOLDER/wxbasicscript-unzipdemo/icon.xpm\" $FOLDER/$MYFILE"
      sed -e "$EDITTEXT" $ICEWMMENU >/tmp/patchedinstall.tmp
      mv -f /tmp/patchedinstall.tmp $ICEWMMENU
INSTALLEDMENUES3="IceWM"
    fi
  fi

#############################
## generate Entry for jwm
  ### register in the jwm menu
  # entry is just above smm
  JWMRC="/root/.jwmrc"

  if [ -f $JWMRC ] ; then  

  MYGREP=`grep "<Menu label=\"DotPups\"" $JWMRC`
  if [ "$MYGREP" = "" ];then

      cp -f $JWMRC /tmp/DOTjwm.pwizard_patched.backup
      EDITTEXT="s\(<RootMenu.label.*$\)\1\n<Menu label=\"DotPups\" icon=\"package.xpm\">\n</Menu>"
      sed -e "$EDITTEXT" $JWMRC >/tmp/patchedinstall.tmp
      sleep 1
      mv -f /tmp/patchedinstall.tmp $JWMRC
      sleep 1
  fi
    # this option is used to prevent the entry from going in more than once
    grep "$FOLDER/$MYFILE" $JWMRC
    if [ $? -ne 0 ] ;then
      cp -f $JWMRC /tmp/DOTjwm.pwizard_patched.backup
      EDITTEXT="s^\(<Menu.label=\"DotPups\".*$\)\1\n<Program label=\"$BINARYNAME\" icon=\"$FOLDER/wxbasicscript-unzipdemo/icon.xpm\">$FOLDER/$MYFILE</Program>"
      sed -e "$EDITTEXT" $JWMRC >/tmp/patchedinstall.tmp
      mv -f /tmp/patchedinstall.tmp $JWMRC
      sleep 1
INSTALLEDMENUES4="JWM"
    fi
  fi 


    INSTALLEDMENUESCHECK=$INSTALLEDMENUES1$INSTALLEDMENUES2$INSTALLEDMENUES3$INSTALLEDMENUES4
    INSTALLEDMENUESALL="\n$INSTALLEDMENUES1\n$INSTALLEDMENUES2\n$INSTALLEDMENUES3\n$INSTALLEDMENUES4\n"
    if [ "$INSTALLEDMENUESCHECK" != ""  ];then
      Xdialog --title "info" --msgbox "Added Menue-entries to $INSTALLEDMENUESALL\nYou must restart them (except Icewm) to see them." 0 0
    fi
################################################
## generate symbolic link in /usr/local/bin

  BINARYNAME=`echo $MYFILE | sed "s^.*/"`
  APPSYMLINK="/usr/local/bin/$BINARYNAME"

  if [ -f "$APPSYMLINK" ];then

    MSG="There already is a file $BINARYNAME in /usr/local/bin.\n\nMay I overwrite it with a symlink to \n$FOLDER/$MYFILE?"
    Xdialog --title "info" --yesno "$MSG" 0 0

    if [ "$?" = "0" ];then
      USESYMLINK=yes
      rm -f "$APPSYMLINK"
      ln -s "$FOLDER/$MYFILE" "$APPSYMLINK"
    fi
  else
      USESYMLINK=yes
      ln -s "$FOLDER/$MYFILE" "$APPSYMLINK"
  fi
#############################

  #### test if PCCC is available (Puppy-Linux)
  if [ ! -f "/root/.packages/packages.txt" ];then

      #### finally open the new folder in Rox and display "goodbye" (Systems without PCCC)
      rox "$FOLDER/wxbasicscript-unzipdemo"
      xmessage -nearmouse "Finished installation. To Uninstall wxbasicscript-unzipdemo, run this installer again."
      exit 0
  fi

  #### Option to register to PCCC

   #### if it was registered before, force registering

   if [ -f "/root/.packages/wxbasicscript-unzipdemo.files" ];then
     RESULT=yes
   else
     RESULT=`xmessage -nearmouse -print -buttons yes,no,"more info" "register to pupget?"`
   fi

    if [ "$RESULT" = "more info" ]; then
      Xdialog --title "info on pupget" --textbox "$MYDIR/pupreg.txt" 0 0&
      RESULT=`xmessage -nearmouse -print -buttons yes,no "register to pupget?"`
    fi

    if [ "$RESULT" = "no" ]; then
      #### finally open the new folder in Rox and display "goodbye" (Puppy: PCCC was NOT used)
      rox "$FOLDER/wxbasicscript-unzipdemo"
      xmessage -nearmouse "Finished installation. To Uninstall wxbasicscript-unzipdemo, run this installer again."
      exit 0
    fi


      #### register to PCCC
      #### avoid double entries in PCCC
      MYGREP=`grep "wxbasicscript-unzipdemo" /root/.packages/alienpackages.txt`
      if [ "$MYGREP" = "" ];then
        echo \"wxbasicscript-unzipdemo\" \"wxbasicscript-unzipdemo\" on \"\" \\>>/root/.packages/alienpackages.txt
      fi

      #### Register Keyword to PCCC
      echo wxbasicscript-unzipdemo>/root/.packages/wxbasicscript-unzipdemo.keyword

      #### Register filelist to PCCC
      rm -f /root/.packages/wxbasicscript-unzipdemo.files
      tar -tzf $MYDIR/wxbasicscript-unzipdemo.tgz | while read a; do echo "$FOLDER/$a"|sed "s/\/$//">>/root/.packages/wxbasicscript-unzipdemo.files ; done
      cat $MYDIR/config.files >> /root/.packages/wxbasicscript-unzipdemo.files

      if [ "$USESYMLINK" = "yes" ];then
        echo "$APPSYMLINK" >> /root/.packages/wxbasicscript-unzipdemo.files
      fi

      ## V03 ##########################################################################################
      ###do the same with files from root.tgz and usr.tgz
      tar -tzf $MYDIR/FILESYSTEM.tgz | while read a; do echo "/$a"|sed "s/\/$//">>/root/.packages/wxbasicscript-unzipdemo.files ; done


      #### finally open the new folder in Rox and display "goodbye" (Puppy: PCCC was used)
      rox "$FOLDER/wxbasicscript-unzipdemo"
      xmessage -nearmouse "Finished installation. To Uninstall wxbasicscript-unzipdemo, use the Pup-Get Package-Manager"



